Whamcloud - gitweb
LU-12672 tests: Correctly determine mdccli in recovery-small test 66
[fs/lustre-release.git] / lustre / tests / recovery-small.sh
index e36b42f..891ac23 100755 (executable)
@@ -2,9 +2,6 @@
 
 set -e
 
-#         bug  5493  LU2034
-ALWAYS_EXCEPT="52 $RECOVERY_SMALL_EXCEPT"
-
 export MULTIOP=${MULTIOP:-multiop}
 PTLDEBUG=${PTLDEBUG:--1}
 LUSTRE=${LUSTRE:-`dirname $0`/..}
@@ -13,6 +10,11 @@ init_test_env $@
 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
 init_logging
 
+ALWAYS_EXCEPT="$RECOVERY_SMALL_EXCEPT "
+# bug number for skipped test:
+ALWAYS_EXCEPT+="               "
+# UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
+
 require_dsh_mds || exit 0
 
 # also long tests: 19, 21a, 21e, 21f, 23, 27
@@ -171,8 +173,8 @@ test_10b() {
        local before=$(date +%s)
        local evict
 
-       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.53) ]] &&
-               skip "Need MDS version at least 2.6.53" && return
+       [[ "$MDS1_VERSION" -lt $(version_code 2.6.53) ]] &&
+               skip "Need MDS version at least 2.6.53"
        do_facet client "stat $DIR > /dev/null"  ||
                error "failed to stat $DIR: $?"
        drop_bl_callback_once "chmod 0777 $DIR" ||
@@ -211,7 +213,7 @@ test_10c() {
                  awk '{sub("_UUID", "", $2); print $2;}')
        #assume one client
        mdccli=$($LCTL dl | grep "${mdtname}-mdc" | awk '{print $4;}')
-       conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
+       conn_uuid=$($LCTL get_param -n mdc.${mdccli}.conn_uuid)
        mdcpath="mdc.${mdccli}.import=connection=${conn_uuid}"
 
        drop_bl_callback_once "chmod 0777 ${workdir}" &
@@ -243,8 +245,8 @@ test_10d() {
        local before=$(date +%s)
        local evict
 
-       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.90) ]] &&
-               skip "Need MDS version at least 2.6.90" && return
+       [[ "$MDS1_VERSION" -lt $(version_code 2.6.90) ]] &&
+               skip "Need MDS version at least 2.6.90"
 
        # sleep 1 is to make sure that BEFORE is not equal to EVICTED below
        sleep 1
@@ -284,11 +286,11 @@ run_test 10d "test failed blocking ast"
 
 test_10e()
 {
-       [[ $(lustre_version_code ost1) -le $(version_code 2.8.58) ]] &&
-               skip "Need OST version at least 2.8.59" && return 0
-       [ $CLIENTCOUNT -lt 2 ] && skip "need two clients" && return 0
+       [[ "$OST1_VERSION" -le $(version_code 2.8.58) ]] &&
+               skip "Need OST version at least 2.8.59"
+       [ $CLIENTCOUNT -lt 2 ] && skip "need two clients"
        [ $(facet_host client) == $(facet_host ost1) ] &&
-               skip "need ost1 and client on different nodes" && return 0
+               skip "need ost1 and client on different nodes"
        local -a clients=(${CLIENTS//,/ })
        local client1=${clients[0]}
        local client2=${clients[1]}
@@ -1288,21 +1290,22 @@ run_test 52 "failover OST under load"
 # test of open reconstruct
 test_53() {
        touch $DIR/$tfile
-       drop_ldlm_reply "openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tfile" ||\
+       drop_mdt_ldlm_reply "openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tfile" ||\
                return 2
 }
 run_test 53 "touch: drop rep"
 
 test_54() {
-       zconf_mount `hostname` $MOUNT2
-        touch $DIR/$tfile
-        touch $DIR2/$tfile.1
-        sleep 10
-        cat $DIR2/$tfile.missing # save transno = 0, rc != 0 into last_rcvd
-        fail $SINGLEMDS
-        umount $MOUNT2
-        ERROR=`dmesg | egrep "(test 54|went back in time)" | tail -n1 | grep "went back in time"`
-        [ x"$ERROR" == x ] || error "back in time occured"
+       zconf_mount $(hostname) $MOUNT2
+       touch $DIR/$tfile
+       touch $DIR2/$tfile.1
+       sleep 10
+       cat $DIR2/$tfile.missing # save transno = 0, rc != 0 into last_rcvd
+       fail $SINGLEMDS
+       umount $MOUNT2
+       ERROR=$(dmesg | egrep "(test 54|went back in time)" | tail -n1 |
+               grep "went back in time")
+       [ x"$ERROR" == x ] || error "back in time occured"
 }
 run_test 54 "back in time"
 
@@ -1322,7 +1325,7 @@ test_55() {
        # Minimum pass speed is 2MBps
        local ddtimeout=64
        # LU-2887/LU-3089 - set min pass speed to 500KBps
-       [ "$(facet_fstype ost1)" = "zfs" ] && ddtimeout=256
+       [ "$ost1_FSTYPE" = zfs ] && ddtimeout=256
 
        # first dd should be finished quickly
        $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-1
@@ -1527,10 +1530,43 @@ run_test 61 "Verify to not reuse orphan objects - bug 17025"
 #}
 #run_test 62 "Verify connection flags race - bug LU-1716"
 
+test_65() {
+       mount_client $DIR2
+
+       #grant lock1, export2
+       $SETSTRIPE -i -0 $DIR2/$tfile || return 1
+       $MULTIOP $DIR2/$tfile Ow  || return 2
+
+#define OBD_FAIL_LDLM_BL_EVICT            0x31e
+       do_facet ost $LCTL set_param fail_loc=0x31e
+       #get waiting lock2, export1
+       $MULTIOP $DIR/$tfile Ow &
+       PID1=$!
+       # let enqueue to get asleep
+       sleep 2
+
+       #get lock2 blocked
+       $MULTIOP $DIR2/$tfile Ow &
+       PID2=$!
+       sleep 2
+
+       #evict export1
+       ost_evict_client
+
+       sleep 2
+       do_facet ost $LCTL set_param fail_loc=0
+
+       wait $PID1
+       wait $PID2
+
+       umount_client $DIR2
+}
+run_test 65 "lock enqueue for destroyed export"
+
 test_66()
 {
-       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.7.51) ]] ||
-               { skip "Need MDS version at least 2.7.51"; return 0; }
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.51) ]] ||
+               skip "Need MDS version at least 2.7.51"
 
        local list=$(comma_list $(osts_nodes))
 
@@ -1539,7 +1575,7 @@ test_66()
 
        # drop 1 reply with UPDATE lock
        mcreate $DIR/$tfile || error "mcreate failed: $?"
-       drop_ldlm_reply_once "stat $DIR/$tfile" &
+       drop_mdt_ldlm_reply_once "stat $DIR/$tfile" &
        sleep 2
 
        # make the re-sent lock to sleep
@@ -1547,8 +1583,9 @@ test_66()
        do_nodes $list $LCTL set_param fail_loc=0x80000136
 
        #initiate the re-connect & re-send
-       local mdccli=$($LCTL dl | awk '/-mdc-/ {print $4;}')
-       local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
+       local mdtname="MDT0000"
+       local mdccli=$($LCTL dl | grep "${mdtname}-mdc" | awk '{print $4;}')
+       local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.conn_uuid)
        $LCTL set_param "mdc.${mdccli}.import=connection=${conn_uuid}"
        sleep 2
 
@@ -1560,38 +1597,24 @@ test_66()
 }
 run_test 66 "lock enqueue re-send vs client eviction"
 
-test_65() {
-       mount_client $DIR2
-
-       #grant lock1, export2
-       $SETSTRIPE -i -0 $DIR2/$tfile || return 1
-       $MULTIOP $DIR2/$tfile Ow  || return 2
-
-#define OBD_FAIL_LDLM_BL_EVICT            0x31e
-       do_facet ost $LCTL set_param fail_loc=0x31e
-       #get waiting lock2, export1
-       $MULTIOP $DIR/$tfile Ow &
-       PID1=$!
-       # let enqueue to get asleep
-       sleep 2
+test_67()
+{
+#define OBD_FAIL_PTLRPC_CONNECT_RACE    0x531
+       $LCTL set_param fail_loc=0x80000531
 
-       #get lock2 blocked
-       $MULTIOP $DIR2/$tfile Ow &
-       PID2=$!
+       local mdtname="MDT0000"
+       local mdccli=$($LCTL dl | grep "${mdtname}-mdc" | awk '{print $4;}')
+       local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
+       $LCTL set_param "mdc.${mdccli}.import=connection=${conn_uuid}" &
        sleep 2
 
-       #evict export1
-       ost_evict_client
-
-       sleep 2
-       do_facet ost $LCTL set_param fail_loc=0
-
-       wait $PID1
-       wait $PID2
+       mds_evict_client
+       sleep 1
 
-       umount_client $DIR2
+       client_reconnect
+       wait
 }
-run_test 65 "lock enqueue for destroyed export"
+run_test 67 "connect vs import invalidate race"
 
 check_cli_ir_state()
 {
@@ -1737,26 +1760,45 @@ test_100()
 }
 run_test 100 "IR: Make sure normal recovery still works w/o IR"
 
-test_101()
+test_101a()
 {
-        do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
-                { skip "MGS without IR support"; return 0; }
+       do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+               skip "MGS without IR support"
 
-        set_ir_status full
+       set_ir_status full
 
-        local OST1_IMP=$(get_osc_import_name client ost1)
+       local ost1_imp=$(get_osc_import_name client ost1)
 
-        # disable pinger recovery
-        lctl set_param -n osc.$OST1_IMP.pinger_recov=0
+       # disable pinger recovery
+       lctl set_param -n osc.$ost1_imp.pinger_recov=0
+       stack_trap "$LCTL set_param -n osc.$ost1_imp.pinger_recov=1" EXIT
 
-        fail ost1
+       fail ost1
 
-        target_instance_match ost1 || error "instance mismatch"
-        nidtbl_versions_match || error "version must match"
+       target_instance_match ost1 || error "instance mismatch"
+       nidtbl_versions_match || error "version must match"
+}
+run_test 101a "IR: Make sure IR works w/o normal recovery"
+
+test_101b()
+{
+       do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
+               skip "MGS without IR support"
 
-        lctl set_param -n osc.$OST1_IMP.pinger_recov=1
+       set_ir_status full
+
+       local ost1_imp=$(get_osc_import_name client ost1)
+
+#define OBD_FAIL_OST_PREPARE_DELAY      0x247
+       do_facet ost1 "$LCTL set_param fail_loc=0x247"
+       # disable pinger recovery
+       $LCTL set_param -n osc.$ost1_imp.pinger_recov=0
+       stack_trap "$LCTL set_param -n osc.$ost1_imp.pinger_recov=1" EXIT
+
+#OST may return EAGAIN if it is not configured yet
+       fail ost1
 }
-run_test 101 "IR: Make sure IR works w/o normal recovery"
+run_test 101b "IR: Make sure IR works w/o normal recovery and proceed EAGAIN"
 
 test_102()
 {
@@ -1926,8 +1968,8 @@ cleanup_106() {
 }
 
 test_106() { # LU-1789
-       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.50) ]] ||
-               { skip "Need MDS version at least 2.3.50"; return 0; }
+       [[ "$MDS1_VERSION" -ge $(version_code 2.3.50) ]] ||
+               skip "Need MDS version at least 2.3.50"
 
 #define OBD_FAIL_MDC_LIGHTWEIGHT         0x805
        $LCTL set_param fail_loc=0x805
@@ -1946,17 +1988,16 @@ test_106() { # LU-1789
        touch $DIR2/$tfile || error "failed to create empty file"
        replay_barrier $SINGLEMDS
 
-       $LCTL set_param debug=console
+       $LCTL set_param debug=ha
        $LCTL clear
        facet_failover $SINGLEMDS
 
-       # lightweight connection must be evicted
+       # lightweight goes through LUSTRE_IMP_RECOVER during failover
        touch -c $DIR2/$tfile || true
        $LCTL dk $TMP/lustre-log-$TESTNAME.log
-       evicted=`awk '/This client was evicted by .*MDT0000/ {
-                                     print;
-                     }' $TMP/lustre-log-$TESTNAME.log`
-       [ -z "$evicted" ] && error "lightweight client not evicted by mds"
+       recovered=$(awk '/MDT0000-mdc-[0-9a-f]*. lwp recover/ { print }' \
+                   $TMP/lustre-log-$TESTNAME.log)
+       [ -z "$recovered" ] && error "lightweight client was not recovered"
 
        # and all operations performed by lightweight client should be
        # synchronous, so the file created before mds restart should be there
@@ -2109,37 +2150,36 @@ test_110f () {
 run_test 110f "remove remote directory: drop slave rep"
 
 test_110g () {
-       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.6.57) ]] ||
-               { skip "Need MDS version at least 2.6.57"; return 0; }
+       [[ "$MDS1_VERSION" -ge $(version_code 2.11.0) ]] ||
+               skip "Need MDS version at least 2.11.0"
 
-       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       local remote_dir=$DIR/$tdir/remote_dir
-       local mdtidx=1
-
-       mkdir -p $remote_dir
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
 
-       createmany -o $remote_dir/f 100
+       mkdir -p $DIR/$tdir
+       touch $DIR/$tdir/$tfile
 
-       #define OBD_FAIL_MIGRATE_NET_REP                0x1800
-       do_facet mds$mdtidx lctl set_param fail_loc=0x1800
-       $LFS migrate -m $mdtidx $remote_dir || error "migrate failed"
-       do_facet mds$mdtidx lctl set_param fail_loc=0x0
+       # OBD_FAIL_MDS_REINT_NET_REP    0x119
+       do_facet mds1 $LCTL set_param fail_loc=0x119
+       $LFS migrate -m 1 $DIR/$tdir &
+       migrate_pid=$!
+       sleep 5
+       do_facet mds1 $LCTL set_param fail_loc=0
+       wait $migrate_pid
 
-       for file in $(find $remote_dir); do
-               mdt_index=$($LFS getstripe -m $file)
-               [ $mdt_index == $mdtidx ] ||
-                       error "$file is not on MDT${mdtidx}"
-       done
+       local mdt_index
+       mdt_index=$($LFS getstripe -m $DIR/$tdir)
+       [ $mdt_index == 1 ] || error "$tdir is not on MDT1"
+       mdt_index=$($LFS getstripe -m $DIR/$tdir/$tfile)
+       [ $mdt_index == 1 ] || error "$tfile is not on MDT1"
 
        rm -rf $DIR/$tdir || error "rmdir failed"
 }
 run_test 110g "drop reply during migration"
 
 test_110h () {
-       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       local server_version=$(lustre_version_code mds1)
-       [[ $server_version -ge $(version_code 2.7.56) ]] ||
-               { skip "Need MDS version at least 2.7.56"; return 0; }
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
 
        local src_dir=$DIR/$tdir/source_dir
        local tgt_dir=$DIR/$tdir/target_dir
@@ -2164,10 +2204,9 @@ test_110h () {
 run_test 110h "drop update reply during cross-MDT file rename"
 
 test_110i () {
-       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       local server_version=$(lustre_version_code mds1)
-       [[ $server_version -ge $(version_code 2.7.56) ]] ||
-               { skip "Need MDS version at least 2.7.56"; return 0; }
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
 
        local src_dir=$DIR/$tdir/source_dir
        local tgt_dir=$DIR/$tdir/target_dir
@@ -2195,10 +2234,9 @@ test_110i () {
 run_test 110i "drop update reply during cross-MDT dir rename"
 
 test_110j () {
-       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
-       local server_version=$(lustre_version_code mds1)
-       [[ $server_version -ge $(version_code 2.7.56) ]] ||
-               { skip "Need MDS version at least 2.7.56"; return 0; }
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.56) ]] ||
+               skip "Need MDS version at least 2.7.56"
 
        local remote_dir=$DIR/$tdir/remote_dir
        local local_dir=$DIR/$tdir/local_dir
@@ -2218,11 +2256,33 @@ test_110j () {
 }
 run_test 110j "drop update reply during cross-MDT ln"
 
+test_110k() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTS"
+       [[ "$MDS1_VERSION" -ge $(version_code 2.12.55) ]] ||
+               skip "Need MDS version at least 2.12.55"
+
+       stop mds2 || error "stop mds2 failed"
+       umount $MOUNT
+
+#define OBD_FAIL_FLD_QUERY_REQ 0x1103
+       do_facet mds2 lctl set_param fail_loc=0x1103
+       start mds2 $(mdsdevname 2) -o abort_recovery ||
+               error "start MDS with abort_recovery should succeed"
+       do_facet mds2 lctl set_param fail_loc=0
+
+       # cleanup
+       stop mds2 || error "cleanup: stop mds2 failed"
+       start mds2 $(mdsdevname 2) || error "cleanup: start mds2 failed"
+       zconf_mount $(hostname) $MOUNT || error "cleanup: mount failed"
+       client_up || error "post-failover df failed"
+}
+run_test 110k "FID_QUERY failed during recovery"
+
 # LU-2844 mdt prepare fail should not cause umount oops
 test_111 ()
 {
-       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.62) ]] ||
-               { skip "Need MDS version at least 2.3.62"; return 0; }
+       [[ "$MDS1_VERSION" -ge $(version_code 2.3.62) ]] ||
+               skip "Need MDS version at least 2.3.62"
 
 #define OBD_FAIL_MDS_CHANGELOG_INIT 0x151
        do_facet $SINGLEMDS lctl set_param fail_loc=0x151
@@ -2301,8 +2361,8 @@ test_115_write() {
 }
 
 test_115a() {
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
-               skip "need at least 2.8.50 on OST" && return 0
+       [ "$OST1_VERSION" -lt $(version_code 2.8.50) ] &&
+               skip "need at least 2.8.50 on OST"
 
        #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK  0x51b
        #define OBD_FAIL_PTLRPC_DROP_BULK        0x51a
@@ -2311,8 +2371,8 @@ test_115a() {
 run_test 115a "read: late REQ MDunlink and no bulk"
 
 test_115b() {
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
-               skip "need at least 2.8.50 on OST" && return 0
+       [ "$OST1_VERSION" -lt $(version_code 2.8.50) ] &&
+               skip "need at least 2.8.50 on OST"
 
        #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK  0x51b
        #define OBD_FAIL_OST_ENOSPC              0x215
@@ -2324,8 +2384,8 @@ test_115b() {
 run_test 115b "write: late REQ MDunlink and no bulk"
 
 test_115c() {
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
-               skip "need at least 2.8.50 on OST" && return 0
+       [ "$OST1_VERSION" -lt $(version_code 2.8.50) ] &&
+               skip "need at least 2.8.50 on OST"
 
        #define OBD_FAIL_PTLRPC_LONG_REPL_UNLINK 0x50f
        #define OBD_FAIL_PTLRPC_DROP_BULK        0x51a
@@ -2334,8 +2394,8 @@ test_115c() {
 run_test 115c "read: late Reply MDunlink and no bulk"
 
 test_115d() {
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
-               skip "need at least 2.8.50 on OST" && return 0
+       [ "$OST1_VERSION" -lt $(version_code 2.8.50) ] &&
+               skip "need at least 2.8.50 on OST"
 
        #define OBD_FAIL_PTLRPC_LONG_REPL_UNLINK 0x50f
        #define OBD_FAIL_OST_ENOSPC              0x215
@@ -2344,8 +2404,8 @@ test_115d() {
 run_test 115d "write: late Reply MDunlink and no bulk"
 
 test_115e() {
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
-               skip "need at least 2.8.50 on OST" && return 0
+       [ "$OST1_VERSION" -lt $(version_code 2.8.50) ] &&
+               skip "need at least 2.8.50 on OST"
 
        #define OBD_FAIL_PTLRPC_LONG_BULK_UNLINK 0x510
        #define OBD_FAIL_OST_ALL_REPLY_NET       0x211
@@ -2354,8 +2414,8 @@ test_115e() {
 run_test 115e "read: late Bulk MDunlink and no reply"
 
 test_115f() {
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
-               skip "need at least 2.8.50 on OST" && return 0
+       [ "$OST1_VERSION" -lt $(version_code 2.8.50) ] &&
+               skip "need at least 2.8.50 on OST"
 
        #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK  0x51b
        #define OBD_FAIL_OST_ALL_REPLY_NET       0x211
@@ -2364,8 +2424,8 @@ test_115f() {
 run_test 115f "read: late REQ MDunlink and no reply"
 
 test_115g() {
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
-               skip "need at least 2.8.50 on OST" && return 0
+       [ "$OST1_VERSION" -lt $(version_code 2.8.50) ] &&
+               skip "need at least 2.8.50 on OST"
 
        #define OBD_FAIL_PTLRPC_LONG_BOTH_UNLINK 0x51c
        test_115_read 0x8000051c 0
@@ -2486,7 +2546,7 @@ test_113() {
        # drop 1 reply with UPDATE lock,
        # resend should not create 2nd lock on server
        mcreate $DIR/$tfile || error "mcreate failed: $?"
-       drop_ldlm_reply_once "stat $DIR/$tfile" || error "stat failed: $?"
+       drop_mdt_ldlm_reply_once "stat $DIR/$tfile" || error "stat failed: $?"
 
        # 2 BL AST will be sent to client, both must find the same lock,
        # race them to not get EINVAL for 2nd BL AST
@@ -2538,10 +2598,9 @@ test_130_base() {
 }
 
 test_130a() {
-       remote_mds_nodsh && skip "remote MDS with nodsh" && return
-       local server_version=$(lustre_version_code $SINGLEMDS)
-       [[ $server_version -ge $(version_code 2.7.2) ]] ||
-               { skip "Need server version newer than 2.7.1"; return 0; }
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.2) ]] ||
+               skip "Need server version newer than 2.7.1"
 
        test_130_base
 
@@ -2551,10 +2610,9 @@ test_130a() {
 run_test 130a "enqueue resend on not existing file"
 
 test_130b() {
-       remote_mds_nodsh && skip "remote MDS with nodsh" && return
-       local server_version=$(lustre_version_code $SINGLEMDS)
-       [[ $server_version -ge $(version_code 2.7.2) ]] ||
-               { skip "Need server version newer than 2.7.1"; return 0; }
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [[ "$MDS1_VERSION" -ge $(version_code 2.7.2) ]] ||
+               skip "Need server version newer than 2.7.1"
 
        test_130_base
        # let the reply to be dropped
@@ -2678,8 +2736,8 @@ test_133() {
        multiop_bg_pause $DIR/$tfile O_jc || return 1
        PID=$!
 
-       #define OBD_FAIL_LDLM_REPLY              0x30c
-       do_nodes $list $LCTL set_param fail_loc=0x8000030c
+       #define OBD_FAIL_MDS_LDLM_REPLY_NET 0x157
+       do_nodes $list $LCTL set_param fail_loc=0x80000157
        kill -USR1 $PID
        echo "waiting for multiop $PID"
        wait $PID || return 2
@@ -2720,6 +2778,104 @@ test_134() {
 }
 run_test 134 "race between failover and search for reply data free slot"
 
+test_135() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.12.51) ] &&
+               skip "Need MDS version at least 2.12.51"
+
+       mkdir -p $DIR/$tdir
+       $LFS setstripe -E 1M -L mdt $DIR/$tdir
+       # to have parent dir write lock before open/resend
+       touch $DIR/$tdir/$tfile
+       #define OBD_FAIL_MDS_LDLM_REPLY_NET 0x157
+       do_nodes $(comma_list $(mdts_nodes)) $LCTL set_param fail_loc=0x80000157
+       openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tdir/$tfile ||
+               error "Failed to open DOM file"
+}
+run_test 135 "DOM: open/create resend to return size"
+
+test_136() {
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [[ "$MDS1_VERSION" -ge $(version_code 2.12.52) ]] ||
+               skip "Need MDS version at least 2.12.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local MDT0=$(facet_svc $SINGLEMDS)
+
+       local clog=$(do_facet mds1 $LCTL --device $MDT0 changelog_register -n)
+       [ -n "$clog" ] || error "changelog_register failed"
+       cl_mask=$(do_facet mds1 $LCTL get_param \
+                               mdd.$MDT0.changelog_mask -n)
+       changelog_chmask "ALL"
+
+       # generate some changelog records to accumulate
+       test_mkdir -i 0 -c 0 $DIR/$tdir || error "mkdir $tdir failed"
+       createmany -m $DIR/$tdir/$tfile 10000 ||
+               error "create $DIR/$tdir/$tfile failed"
+
+       local size1=$(do_facet $SINGLEMDS \
+                     $LCTL get_param -n mdd.$MDT0.changelog_size)
+       echo "Changelog size $size1"
+
+       #define OBD_FAIL_LLOG_PURGE_DELAY                   0x1318
+       do_nodes $mdts $LCTL set_param fail_loc=0x1318 fail_val=30
+
+       # launch changelog_deregister in background on MDS
+       do_facet mds1 "nohup $LCTL --device $MDT0 changelog_deregister $clog \
+                       > foo.out 2> foo.err < /dev/null &"
+       # give time to reach fail_loc
+       sleep 15
+
+       # fail_loc will make MDS sleep in the middle of changelog_deregister
+       # take this opportunity to abruptly kill MDS
+       FAILURE_MODE_save=$FAILURE_MODE
+       FAILURE_MODE=HARD
+       fail mds1
+       FAILURE_MODE=$FAILURE_MODE_save
+
+       do_nodes $mdts $LCTL set_param fail_loc=0x0 fail_val=0
+
+       local size2=$(do_facet $SINGLEMDS \
+                     $LCTL get_param -n mdd.$MDT0.changelog_size)
+       echo "Changelog size $size2"
+       local clog2=$(do_facet $SINGLEMDS "$LCTL get_param -n \
+                       mdd.$MDT0.changelog_users | grep $clog")
+       echo "After crash, changelog user $clog2"
+
+       [ -n "$clog2" -o $size2 -lt $size1 ] ||
+               error "changelog record count unchanged"
+
+       do_facet mds1 $LCTL set_param mdd.$MDT0.changelog_mask=\'$cl_mask\' -n
+}
+run_test 136 "changelog_deregister leaving pending records"
+
+test_137() {
+       df $DIR
+       mkdir -p $DIR/d1
+       mkdir -p $DIR/d2
+       dd if=/dev/zero of=$DIR/d1/$tfile bs=4096 count=1
+       dd if=/dev/zero of=$DIR/d2/$tfile bs=4096 count=1
+       cancel_lru_locks osc
+
+       #define OBD_FAIL_PTLRPC_RESEND_RACE      0x525
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000525"
+
+       # RPC1: any reply is to be delayed to disable last_xid logic
+       ln $DIR/d1/$tfile $DIR/d1/f2 &
+       sleep 1
+
+       # RPC2: setattr1 reply is delayed & resent
+       # original reply comes to client; the resend get asleep
+       chmod 666 $DIR/d2/$tfile
+
+       # RPC3: setattr2 on the same file; run ahead of RPC2 resend
+       chmod 777 $DIR/d2/$tfile
+
+       # RPC2 resend wakes up
+       sleep 5
+       [ $(stat -c "%a" $DIR/d2/$tfile) == 777 ] || error "resend got applied"
+}
+run_test 137 "late resend must be skipped if already applied"
+
 complete $SECONDS
 check_and_cleanup_lustre
 exit_status